#include "bsp.h"
void AdcInit(void)
{
        CLK_PeripheralClockConfig(CLK_Peripheral_ADC1, ENABLE);
	ADC_Init(ADC1,ADC_ConversionMode_Single,ADC_Resolution_12Bit,ADC_Prescaler_1);
	ADC_SamplingTimeConfig(ADC1, ADC_Group_SlowChannels, ADC_SamplingTime_384Cycles);
	ADC_Cmd(ADC1,ENABLE); 
        ADC_Cmd(ADC1,DISABLE);      
}
void bsp_init(void)
{
      disableInterrupts();
      bsp_clk_init();
      bsp_time4_init();
      bsp_usart_init();
      SpiInit1();
      bsp_gpio_init();
      SoftDelayMs(10);
      FixedParaDeal();
      SoftDelayMs(10);
      printf("AT+RST:OK!\r\n");
      WatchDogInit();
      enableInterrupts();
}


void WatchDogInit(void)
{
    IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);//Ź
    IWDG_SetPrescaler(IWDG_Prescaler_256);//ŹԤƵ
    IWDG_SetReload(IWDG_500MS_REST);//ÿŹλʱ
    IWDG_Enable();//Ź
}

void FeedWatchDog(void)
{
    IWDG_ReloadCounter();//Źλ ʹʱ뷢Źλִ
}
  
  
  
  
