#include "IIC.h"
//frequent 400kHZ
uint32_t T = 0;
void Delay5us(void)
{
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();	
}
//i2c pins initial
void HMC5883_InitPin(void)
{
    GPIOC->DDR |= (I2C_SCL_PIN)|(I2C_SDA_PIN);
    GPIOC->CR1 |= (I2C_SCL_PIN)|(I2C_SDA_PIN);
    GPIOC->CR2 |= (I2C_SCL_PIN)|(I2C_SDA_PIN);
    GPIOC->ODR &= ~((I2C_SCL_PIN)|(I2C_SDA_PIN));
    //GPIO_Init(I2C_GPIO,I2C_SCL_PIN,GPIO_Mode_Out_PP_Low_Fast);
    //GPIO_Init(I2C_GPIO,I2C_SDA_PIN,GPIO_Mode_Out_PP_High_Fast);
    SCL_L;
    Delay5us();Delay5us();Delay5us();Delay5us();Delay5us();Delay5us();
    Delay5us();Delay5us();Delay5us();Delay5us();Delay5us();Delay5us();
    Delay5us();Delay5us();Delay5us();Delay5us();Delay5us();Delay5us();
    //bsp_DelayMS(3);Delay5us();
    asm("NOP;");
}

bool HMC5883_Start(void)
{
	SDA_H;
	SCL_H;
        Delay5us();
	SDA_L;
        Delay5us();
	SCL_L;
	return TRUE;
}

void HMC5883_Stop(void)
{	
	SDA_L;
        SCL_H;
	Delay5us();
        SDA_H;
        Delay5us();
        SCL_L;
        Delay5us();
}

bool HMC5883_WaitACK(void)
{
        SDA_H;
        SDA_IN;
        Delay5us();
        SCL_H;
        Delay5us(); Delay5us();
        if(SDA_read){SCL_L;SDA_OUT;return FALSE;}
        Delay5us();  Delay5us();
        SCL_L;
        SDA_OUT;
        return TRUE;
}

/**************************************
Ӧź
ڲ:ack (0:ACK 1:NAK)
**************************************/
void HMC5883_SendACK(bool ack)
{
	if(ack==TRUE)SDA_H;
	else{SDA_L;}
        Delay5us();
	SCL_H;
        Delay5us();
        SCL_L;

}

/*I2CNoACK----------------------------------------*/
void I2C_NoAck(void)
{	
	SCL_L;
	Delay5us();
	SDA_H;
	Delay5us();
	SCL_H;
	Delay5us();
	SCL_L;
	Delay5us();
} 


void HMC5883_SendByte(BYTE dat)
{
    BYTE i;

    for (i=0; i<8; i++)         //8λ
    {
        if(dat&0x80)SDA_H;
        else
          SDA_L;
        Delay5us();Delay5us();
        SCL_H;
        Delay5us();Delay5us();
        SCL_L;
        Delay5us();
        dat<<=1;
    }
    if(!HMC5883_WaitACK())return;
}
/**************************************
IIC߽һֽ
**************************************/
BYTE HMC5883_RecvByte()
{
    BYTE i;
    BYTE dat = 0;
    SDA_H; 
    SDA_IN;
    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL_H;             //ʱ
        Delay5us();             //ʱ
        if(SDA_read)dat|=0x01;//               
        SCL_L;                //ʱ
        Delay5us();             //ʱ
    }
    SDA_OUT;
    return dat;
}


//************************д뵥ֽ***************************

void Single_Write_HMC5883(uchar SlaveAddress,uchar REG_Address,uchar REG_data)
{
    HMC5883_Start();                  //ʼź
    HMC5883_SendByte(SlaveAddress);   //豸ַ+дź
    HMC5883_SendByte(REG_Address);    //ڲĴַοpdf
    HMC5883_SendByte(REG_data);       //ڲĴݣοpdf
    HMC5883_Stop();
    //ֹͣź
}



//************************ȡڲĴ*************************
uchar Single_Read_HMC5883(uchar SlaveAddress,uchar REG_Address)
{   
     uchar REG_data;
     asm("NOP;");
     HMC5883_Start();                          //ʼź
     HMC5883_SendByte(SlaveAddress);           //豸ַ+дź
     HMC5883_SendByte(REG_Address);            //ʹ洢Ԫַ0ʼ	
     HMC5883_Start();                          //ʼź
     HMC5883_SendByte(SlaveAddress+1);         //豸ַ+ź
     REG_data=HMC5883_RecvByte();              //Ĵ
            HMC5883_SendACK(TRUE);   
            HMC5883_Stop();                           //ֹͣź
     return REG_data; 
}
/*
//************************ȡڲĴ*************************
uchar Single_Read_HMC5883(uchar SlaveAddress,uchar REG_Address)
{   
     uchar REG_data;
     HMC5883_Start();                          //ʼź
     HMC5883_SendByte(SlaveAddress);           //豸ַ+дź
     HMC5883_SendByte(REG_Address);            //ʹ洢Ԫַ0ʼ	
     HMC5883_Start();                          //ʼź
     HMC5883_SendByte(SlaveAddress+1);         //豸ַ+ź
     REG_data=HMC5883_RecvByte();              //Ĵ
            HMC5883_SendACK(TRUE);   
            HMC5883_Stop();                           //ֹͣź
     return REG_data; 
}
*/

void Multiple_Read_HMC5883(uchar SlaveAddress,uchar *BUFF)
{   uchar i;
    HMC5883_Start();                          //ʼź
    HMC5883_SendByte(SlaveAddress);           //豸ַ+дź
    HMC5883_SendByte(0x00);                   //ʹ洢Ԫַ0x3ʼ	
    HMC5883_Start();                          //ʼź
    HMC5883_SendByte(SlaveAddress+1);         //豸ַ+ź
    for (i=0; i<6; i++)                      //ȡ6ַݣ洢BUF
    {
        BUFF[i] = HMC5883_RecvByte();          //BUF[0]洢
        if (i == 5)
        {
           HMC5883_SendACK(TRUE);                //һҪNOACK
        }
        else
        {
          HMC5883_SendACK(FALSE);                //ӦACK
        }
   }
    HMC5883_Stop();                          //ֹͣź
}

//ʼHMC5883Ҫοpdf޸****

uint8_t hhj = 0;
void Init_HMC5883()
{
     HMC5883_InitPin();
     Single_Write_HMC5883(SLAVE_ADD,0x0a,0x00);
     Single_Write_HMC5883(SLAVE_ADD,0x09,0x1d);  
     Single_Write_HMC5883(SLAVE_ADD,0x0B,0x01);
}



