/**
  ******************************************************************************
  * @file    i2c.h
  * @author  MCD Application Team
  * @version V1.0.0
  * @date    24-11-2014
  * @brief   
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************  
  */ 

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __I2C_H
#define __I2C_H

/* Includes ------------------------------------------------------------------*/
#include "stm8l15x_conf.h"
#include "user.h"
/*ģI2C˿붨*/
#define I2C_GPIO				GPIOC
#define I2C_SCL_PIN			GPIO_Pin_1
#define I2C_SDA_PIN			GPIO_Pin_0

#define SCL_H         I2C_GPIO->ODR |= I2C_SCL_PIN
#define SCL_L         I2C_GPIO->ODR &= (uint8_t)( ~I2C_SCL_PIN )

#define SDA_H         I2C_GPIO->ODR |= I2C_SDA_PIN
#define SDA_L         I2C_GPIO->ODR &= (uint8_t)( ~I2C_SDA_PIN )

#define SDA_read      I2C_GPIO->IDR  & (uint8_t)(I2C_SDA_PIN)

 
void I2C_GPIO_Init(void);

void  Single_WriteI2C(uint8_t REG_Address,uint8_t REG_data);        //I2Cд
uint8_t Single_ReadI2C(uint8_t REG_Address);                        //ȡI2C
void Multiple_Read_QMC5883(void);
u8 i2ctest(void);

#endif