/**SX78drive**/
/**20171226**/
/**Ȯҹ**/
#include "SX7x.h"
SX7XSTR SX78Str;
LORAPARASTR LoraPara;
uint8_t DelayTime = 0;
uint8_t Delay_2s = 0;
uint8_t CadDecTime = 0;
uint8_t Sx1278SleepTime = 100;
uint8_t Sx1278RxTimeout = 100;
void SX78RxInit();
void DioPinsInit(void)
{
  //SX78Str.SX7xDelay;
}
uint8_t SX7xChangeModel(uint8_t Model)//sleep or standy ......
{
		uint8_t TempModel;
		TempModel = spi0ReadWrite(REG_LR_OPMODE,0xff,read);
		TempModel &= RF_OPMODE_MASK;
		TempModel |=Model;
		spi0ReadWrite(REG_LR_OPMODE,TempModel,write);
		TempModel = spi0ReadWrite(REG_LR_OPMODE,0xff,read);
		return TempModel;
}

uint8_t SX7xChangeModulation(uint8_t Modulation)//lora on or lora off
{
		uint8_t TempModulation;
		TempModulation = spi0ReadWrite(REG_LR_OPMODE,0xff,read);
		SX7xChangeModel(RF_OPMODE_SLEEP);
		TempModulation &= RF_OPMODE_LONGRANGEMODE_MASK;
		TempModulation |= (Modulation);
		spi0ReadWrite(REG_LR_OPMODE,TempModulation,write);
		TempModulation = spi0ReadWrite(REG_LR_OPMODE,0xff,read);
		return TempModulation;
}

uint8_t SX7xChangeCarrFre(uint8_t FrMSB,uint8_t FrMID,uint8_t FrLSB)//0x6C 0x80 0x00 = 434MHz		1==ok,0==no
{
		spi0ReadWrite(REG_LR_FRFMSB,FrMSB,write);
		spi0ReadWrite(REG_LR_FRFMID,FrMID,write);
		spi0ReadWrite(REG_LR_FRFLSB,FrLSB,write);
		if((spi0ReadWrite(REG_LR_FRFMSB,0xff,read)==FrMSB)&&\
			 (spi0ReadWrite(REG_LR_FRFMID,0xff,read)==FrMID)&&\
			 (spi0ReadWrite(REG_LR_FRFLSB,0xff,read)==FrLSB))return 1;
		return 0;
}

uint8_t SX7xPaConfig(uint8_t PaSect,uint8_t MaxPower,uint8_t OutputPower)//default 0x00,0x04,0x0f;1==ok,0==no
{
		uint8_t temp;
		temp = (PaSect<<7)|(MaxPower<<4)|(OutputPower);
		spi0ReadWrite(REG_LR_PACONFIG,temp,write);
		if(temp==spi0ReadWrite(REG_LR_PACONFIG,0xff,read))return 1;
		return 0;
}

uint8_t SX7xPaRampConfig(uint8_t PaRamp)
{
	  uint8_t temp;
		temp = spi0ReadWrite(REG_LR_PARAMP,0xff,read);
		temp &= RF_PARAMP_MASK;
		temp |= (PaRamp&(~RF_PARAMP_MASK));
		spi0ReadWrite(REG_LR_PARAMP,temp,write);
		if(temp==spi0ReadWrite(REG_LR_PARAMP,0xff,read))return 1;
		return 0;
}

uint8_t SX7xOcpConig(uint8_t OcpOn,uint8_t OcpTrim)//0x01,0x0b//overload current protection
{
		uint8_t temp;
		temp = (OcpOn<<5)|(OcpTrim);
		spi0ReadWrite(REG_LR_OCP,temp,write);
		temp = spi0ReadWrite(REG_LR_OCP,0xff,read);
		return temp;
}

uint8_t SX7xLnaConfig(uint8_t LnaGain,uint8_t LnaBoostLf,uint8_t LnaBoostHf)
{
		uint8_t temp;
		temp = (LnaGain<<5)|(LnaBoostLf<<3)|(LnaBoostHf);
		spi0ReadWrite(REG_LR_LNA,temp,write);
		temp = spi0ReadWrite(REG_LR_LNA,0xff,read);
		return temp;
}

uint8_t SX7xFifoAddrCfg(uint8_t Addr,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_FIFOADDRPTR,Addr,write);
		}
		return spi0ReadWrite(REG_LR_FIFOADDRPTR,0xff,read);
}

uint8_t SX7xFifoTxBaseAddrCfg(uint8_t Addr,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_FIFOTXBASEADDR,Addr,write);
		}
		return spi0ReadWrite(REG_LR_FIFOTXBASEADDR,0xff,read);
}

uint8_t SX7xFifoRxBaseAddrCfg(uint8_t Addr,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_FIFORXBASEADDR,Addr,write);
		}
		return spi0ReadWrite(REG_LR_FIFORXBASEADDR,0xff,read);
}

uint8_t SX7xFifoRxCurrentAddrRead(void)
{
		return spi0ReadWrite(REG_LR_FIFORXCURRENTADDR,0xff,read);
}

uint8_t SX7xIrqFlagsMaskCfg(uint8_t IrqFlagsMask,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_IRQFLAGSMASK,IrqFlagsMask,write);
		}
		return spi0ReadWrite(REG_LR_IRQFLAGSMASK,0xff,read);
}

uint8_t SX7xIrqFlagsDeal(uint8_t IrqFlag,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_IRQFLAGS,IrqFlag,write);
		}
		return spi0ReadWrite(REG_LR_IRQFLAGS,0xff,read);
}

uint8_t SX7xRxNbBytesRead(void)
{
		return spi0ReadWrite(REG_LR_NBRXBYTES,0xff,read);
}

uint16_t SX7xRxHeaderCntValueRead(void)
{
		uint16_t temp;
		temp = spi0ReadWrite(REG_LR_RXHEADERCNTVALUEMSB,0xff,read);
		temp = (temp<<8) | spi0ReadWrite(REG_LR_RXHEADERCNTVALUELSB,0xff,read);
	  return temp;
}

uint16_t SX7xPacketCntRead(void)
{
		uint16_t temp;
		temp = spi0ReadWrite(REG_LR_RXPACKETCNTVALUEMSB,0xff,read);
		temp = (temp<<8) | spi0ReadWrite(REG_LR_RXPACKETCNTVALUELSB,0xff,read);
	  return temp;
}

uint8_t SX7xModemStateRead(void)
{
		return spi0ReadWrite(REG_LR_MODEMSTAT,0xff,read);
}

uint8_t PktSnrValueRead(void)
{
		return spi0ReadWrite(REG_LR_PKTSNRVALUE,0xff,read);
}

uint8_t PktRssiValueRead(void)
{
		return spi0ReadWrite(REG_LR_PKTRSSIVALUE,0xff,read);
}

uint8_t RssiValueRead(void)
{
		return spi0ReadWrite(REG_LR_RSSIVALUE,0xff,read);
}

uint8_t HopChannelRead(void)
{
		return spi0ReadWrite(REG_LR_HOPCHANNEL,0xff,read);
}

uint8_t ModemConfig1Deal(uint8_t Bw,uint8_t Rate,uint8_t ImplicitHeader,enum DataDeal deal)
{
		uint8_t temp;
		temp = ((Bw&0x0F)<<4)|((Rate&0x07)<<1)|(ImplicitHeader);
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_MODEMCONFIG1,temp,write);
		}
		return spi0ReadWrite(REG_LR_MODEMCONFIG1,0xff,read);
}

uint8_t ModemConfig2Deal(uint8_t SprFac,uint8_t TxConMode,uint8_t RxLoadCRC,uint8_t SymTineoutMsb,enum DataDeal deal)
{
		uint8_t temp;
		temp = ((SprFac&0x0F)<<4)|((TxConMode&0x01)<<3)|((RxLoadCRC&0x01)<<2)|(SymTineoutMsb&0x02);
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_MODEMCONFIG2,temp,write);
		}
		return spi0ReadWrite(REG_LR_MODEMCONFIG2,0xff,read);
}

uint8_t ModemConfig3Deal(uint8_t LowDataRateOp,uint8_t AgcAutoOn,enum DataDeal deal)
{
		uint8_t temp;
		temp = ((LowDataRateOp&0x01)<<3)|((AgcAutoOn&0x01)<<2);
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_MODEMCONFIG3,temp,write);
		}
		return spi0ReadWrite(REG_LR_MODEMCONFIG3,0xff,read);
}

uint8_t SymbTimeoutLsbCfg(uint8_t SymTineoutLsb,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_SYMBTIMEOUTLSB,SymTineoutLsb,write);
		}
		return spi0ReadWrite(REG_LR_SYMBTIMEOUTLSB,0xff,read);
}

uint16_t PreambleCfg(uint8_t Msb,uint8_t Lsb,enum DataDeal deal)
{
		uint16_t temp;
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_PREAMBLEMSB,Msb,write);
				spi0ReadWrite(REG_LR_PREAMBLELSB,Lsb,write);
		}
		temp = spi0ReadWrite(REG_LR_PREAMBLEMSB,0xff,read);
		temp = (temp<<8) | spi0ReadWrite(REG_LR_PREAMBLELSB,0xff,read);
		return temp;
}

uint8_t PayloadLenCfg(uint8_t PayloadLen,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_PAYLOADLENGTH,PayloadLen,write);
		}
		return spi0ReadWrite(REG_LR_PAYLOADLENGTH,0xff,read);
}

uint8_t MaxPayloadLenCfg(uint8_t MaxPayloadLen,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_PAYLOADMAXLENGTH,MaxPayloadLen,write);
		}
		return spi0ReadWrite(REG_LR_PAYLOADMAXLENGTH,0xff,read);
}

uint8_t HopPeriodCfg(uint8_t HopPeriod,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_HOPPERIOD,HopPeriod,write);
		}
		return spi0ReadWrite(REG_LR_HOPPERIOD,0xff,read);
}

uint8_t FifoRcByteAddrRead(void)
{
		return spi0ReadWrite(REG_LR_FIFORXBYTEADDR,0xff,read);
}

uint8_t PaDacCfg(uint8_t PaDac,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_PADAC,PaDac,write);
		}
		return spi0ReadWrite(REG_LR_PADAC,0xff,read);
}

uint8_t DioMapping(uint8_t DioMap,enum DataDeal deal)
{
		if(deal==write)
		{
				spi0ReadWrite(REG_LR_DIOMAPPING1,DioMap,write);
		}
		return spi0ReadWrite(REG_LR_DIOMAPPING1,0xff,read);

}

uint8_t VersionRead()
{
		return spi0ReadWrite(REG_LR_VERSION,0xff,read);
}

void SX7xPackBytes(uint8_t addr,uint8_t *BUFF,uint8_t len)
{
		SPI0_SCS_L;
		int i = 0;
		SpiInOut(addr|0x80);
		while(i<len)
		{
					SpiInOut(BUFF[i++]);
		}
		SPI0_SCS_H;
		/*
		spi0ReadWrite(REG_LR_FIFOADDRPTR,*BUFF++,write);
		SPI0_SCS_L;
		SPI0_DELAY;
		len--;
		while(len--)
		{
					SpiInOut(*BUFF++);
					//SPI0_DELAY;
		}
		SPI0_SCS_H;
		*/
}

void SX7xReadBytes(uint8_t addr,uint8_t *BUFF,uint8_t len)
{
		SPI0_SCS_L;
		int i = 0;
		SpiInOut(addr&0x7F);
		while(len--)
		{
				BUFF[i++]=SpiInOut(0xff);
		}
		SPI0_SCS_H;
}
uint8_t temps=0x00;
uint8_t temT[10] = {0};
uint8_t tempRegistrt[100]={0};
void SX7xInit(void)
{
		int i=0;
		temps = SX7xChangeModel(RF_OPMODE_SLEEP);//
		temps = SX7xChangeModulation(RF_OPMODE_LONGRANGEMODE_ON);//
		temps = SX7xChangeModel(RF_OPMODE_STANDBY);//
		SX7xChangeCarrFre(LoraPara.RxChannel[2],LoraPara.RxChannel[1],LoraPara.RxChannel[0]);
                //SX7xChangeCarrFre(0x88,LoraPara.RxChannel[1],LoraPara.RxChannel[0]);
                //SX7xChangeCarrFre(0x7C,0xF0,0x00);
		SX7xPaConfig(0x01,0x04,0x0f);
		SX7xPaRampConfig(0x09);
		SX7xOcpConig(0x01,0x0b);
		SX7xLnaConfig(0x01,0x00,0x00);
		SX7xFifoTxBaseAddrCfg(0x00,write);
		SX7xFifoRxBaseAddrCfg(0x00,write);
		SX7xIrqFlagsMaskCfg(0x00,write);
		SX7xIrqFlagsDeal(0x00,write);
		temps = MaxPayloadLenCfg(0x80,write);
		ModemConfig1Deal(LoraPara.RxBW,0x01,0x00,write);
		ModemConfig2Deal(LoraPara.RxSF,0x00,0x00,0x03,write);
		ModemConfig3Deal(0x01,0x00,write);
		SymbTimeoutLsbCfg(0xff,write);
		//PreambleCfg(0x00,0x08,write);
		HopPeriodCfg(0x00,write);
		PaDacCfg(0x07,write);
		//printf("Version = %d\n",VersionRead());
		//SX7xChangeModel(RF_OPMODE_SLEEP);
                SX78RxInit();
		for(i=1;i<100;i++)
		{
				tempRegistrt[i] = spi0ReadWrite(i,0xff,read);
		}
//		temps = SX7xIrqFlagsDeal(0xff,write);
//		temps = SX7xIrqFlagsDeal(0xff,read);
		asm("NOP;");
                if(LOW_POWER_TEST)SX7xChangeModel(RF_OPMODE_SLEEP);
}
//void SX78TxInit()
//{
//		SX7xChangeModel(RF_OPMODE_STANDBY);
//		SX7xFifoTxBaseAddrCfg(0x00,write);
//		SX7xFifoAddrCfg(0x00,write);
//		ModemConfig2Deal(0x09,0x00,0x01,0x03,write);//set SF,set CRC
//		PreambleCfg(0x00,0x08,write);
//		HopPeriodCfg(0x00,write);
//		DioMapping(0x40,write);//DIO0-TxDone
//}
uint8_t ttt2[20]={0};
uint8_t SX7xTxStart(uint8_t *BUFF,uint16_t len,bool *TxFlag)
{
		static uint8_t state = 0;
		if(*TxFlag)
		{
			*TxFlag = FALSE;
			state=0;
		}
		switch(state)
		{
			case 0:
			{
					temps = PayloadLenCfg(len,write);
					SX7xPackBytes(REG_LR_FIFO,BUFF,len);
					//SX7xReadBytes(REG_LR_FIFO,ttt2,temps);
					temps = SX7xChangeModel(RF_OPMODE_TRANSMITTER);//
					state = 1;
					len = 0;
					break;
			}
			case 1:
			{
					temps = SX7xIrqFlagsDeal(0xff,read);
					if(temps&0x08)//if(DIOREAD(DIO0)==1)////
					{
							temps = SX7xIrqFlagsDeal(0xff,write);//
							//temps = SX7xIrqFlagsDeal(0xff,read);
							state = 2;
					}
					break;
			}
			case 2:
			{
					temps = SX7xChangeModel(RF_OPMODE_STANDBY);
					state = 3;
					break;
			}
			default:
				break;
		}
		return state;
}
//uint8_t temps = 0;
void SX78RxInit()
{

		SX7xChangeModel(RF_OPMODE_STANDBY);
                SX7xChangeCarrFre(LoraPara.RxChannel[2],LoraPara.RxChannel[1],LoraPara.RxChannel[0]);
                //SX7xChangeCarrFre(0x6C,0x80,0x00);
                //SX7xChangeCarrFre(0x7C,0xF0,0x00);
                ModemConfig2Deal(LoraPara.RxSF,0x00,0x00,0x03,write);//set SF,set CRC
                ModemConfig1Deal(LoraPara.RxBW,0x01,0x00,write);
		SX7xFifoRxBaseAddrCfg(0x00,write);
		SX7xChangeModel(RF_OPMODE_RECEIVER);
		memset(SX78Str.SX7xRxStr,0,0x80*2*sizeof(uint8_t));
		temps = DioMapping(0x02,write);//DIO0-RxDone,DIO3-PayloadCrcError
                PreambleCfg(0x00,0x61,write);
		//temps = SX7xIrqFlagsMaskCfg(0X00,read);
	asm("NOP;");
}
void SX78TxInit()
{
		SX7xChangeModel(RF_OPMODE_STANDBY);
                //SX7xChangeCarrFre(0x6C,0x80,0x00);
                SX7xChangeCarrFre(LoraPara.TxChannel[2],LoraPara.TxChannel[1],LoraPara.TxChannel[0]);
                //SX7xChangeCarrFre(0x7C,0xF0,0x00);
		SX7xFifoTxBaseAddrCfg(0x00,write);
		SX7xFifoAddrCfg(0x00,write);
		ModemConfig2Deal(LoraPara.TxSF,0x00,0x00,0x03,write);//set SF,set CRC
                ModemConfig1Deal(LoraPara.TxBW,0x01,0x00,write);
		PreambleCfg(0x01,0xE6,write);
		HopPeriodCfg(0x00,write);
		DioMapping(0x40,write);//DIO0-TxDone
}
bool SX7xRxStart(uint8_t *BUFF,uint16_t *len)
{
		static uint8_t RxBytesCnt = 0;
		temps = SX7xIrqFlagsDeal(0xff,read);
		if(temps!=0)
		{
				asm("NOP;");
		}
		if((temps&0x40))////||(temps&0x80)if(DIOREAD(DIO0)==1)//
		{

				if(!(temps&0x20))//if(DIOREAD(DIO3)==1)//
				{
						SX7xIrqFlagsDeal(0xff,write);
						SX7xFifoAddrCfg(0x00,write);
						RxBytesCnt = SX7xRxNbBytesRead();
						*len = RxBytesCnt;
						SX7xReadBytes(REG_LR_FIFO,BUFF,RxBytesCnt);
						SX7xIrqFlagsDeal(0xff,write);
						return TRUE;
				}
				else
				{
						SX7xIrqFlagsDeal(0xff,write);//SX7xIrqFlagsDeal(temps&(~(0x40|0x20)),write);
				}
				SX7xFifoAddrCfg(0x00,write);
		}
		if(temps&0x80)
		{
				SX7xIrqFlagsDeal(temps&(~0x80),write);
		}
		return FALSE;
}

void SX78CadInit(void)
{
		SX7xChangeModel(RF_OPMODE_STANDBY);
		//temps = SX7xIrqFlagsMaskCfg(0x00,read);
		//SX7xIrqFlagsMaskCfg(temp&0x37,write);
                PreambleCfg(0x03,0xCC,write);
                //PreambleCfg(0x00,0x08,write);
		SX7xChangeModel(RFLR_OPMODE_CAD);
		//DioMapping(0x80,write);//DIO0-CadDone
                SX7xIrqFlagsDeal(0xff,write);
}

bool SX78CadIng(void)
{
		temps = SX7xIrqFlagsDeal(0xff,read);
	asm("NOP;");
		if(temps&0x01)////if(DIOREAD(DIO0)==1)//
		{
                                temps = SX7xIrqFlagsDeal(0xff,read);
                                asm("NOP;");
				SX7xIrqFlagsDeal(0xff,write);				
                                temps = SX7xIrqFlagsDeal(0xff,read);
                                asm("NOP;");
				return TRUE;
		}
                
		asm("NOP;");
		return FALSE;
}
void SX7xTest(enum CMDS *CMD)
{
		if(!SX78Str.SX7xDelay)return;
		SX78Str.SX7xDelay = FALSE;
		//uint8_t temp[3] = {ledR,ledG,ledB};
		static enum SX7XSTATE Sx7xState=SpiInit;
		if((*CMD==CmdTX))//&&(Sx7xState==Sx7xCadIng)
		{
				*CMD = CmdIdle;
				Sx7xState = Sx7xTxInit;
		}
		switch(Sx7xState)
		{
				case SpiInit:
				{
						SpiInit1();//spi0Test();if(spi0Str.SpiInitFlag)
						Sx7xState = Sx7xInit;
                                                //DelayTime = 1;
						break;
				}
				case Sx7xIdle:
				{
                                                if(Sx1278SleepTime==0)
                                                {
                                                  Sx1278SleepTime = 10;
                                                  Sx7xState = Sx7xCadInit;
                                                }
                                                //if(Delay_2s==0)Sx7xState = Sx7xRxInit;
						break;
				}
				case Sx7xInit:
				{
                                                
                                                //if(DelayTime)return;
						SX7xInit();
						Sx7xState = Sx7xRxInit;
                                                if(LOW_POWER_TEST)Sx7xState = Sx7xIdle;
						break;
				}
				case Sx7xRxInit:
				{
						SX78RxInit();
						Sx7xState = Sx7xRxIng;
						break;
				}
				case Sx7xRxIng:
				{                                 
						if(SX7xRxStart(SX78Str.SX7xRxStr,&SX78Str.SX7xRxlen))
						{

								int i = 0;
                                                                GPIO_ToggleBits(GPIOA,GPIO_Pin_5);
								SX78Str.Sx7xRxFlag = TRUE;
                                                                if((SX78Str.SX7xRxStr[0]==SystemPara.PcID[0])&&(SX78Str.SX7xRxStr[1]==SystemPara.PcID[1])&&(SX78Str.SX7xRxStr[2]==SystemPara.PcID[2]))
                                                                {
                                                                    for(i=3;i<SX78Str.SX7xRxlen;i++)
                                                                    {
                                                                                UsartPrint(&SX78Str.SX7xRxStr[i],1);//app_uart_put(SX78Str.SX7xRxStr[i]);
                                                                    }
                                                                }
								//app_uart_put(SX78Str.SX7xRxlen);
								memset(SX78Str.SX7xRxStr,0,0x80*2*sizeof(uint8_t));
								Sx7xState = Sx7xInit;//Sx7xState = Sx7xCadInit;
						}
						if(SX78Str.SX7xTimeOut == 0)
						{
								Sx7xState = Sx7xCadInit;
						}
//                                                else if(Sx1278RxTimeout==0)
//                                                {
//                                                    Sx7xState = Sx7xInit;
//                                                }
						break;
				}
				case Sx7xCadInit:
				{
                                                
                                                CadDecTime = 2;
						SX78CadInit();
						Sx7xState = Sx7xCadIng;                                               
						break;
				}
				case Sx7xCadIng:
				{
						if(SX78CadIng())
						{
                                                        //GPIO_ToggleBits(GPIOA,GPIO_Pin_5);
                                                        Sx1278RxTimeout = 100;
							Sx7xState = Sx7xRxInit;
							SX78Str.SX7xTimeOut = SX7XTIMEOUT;
						}
                                                else if(CadDecTime==0)
                                                {
                                                      Sx7xState = Sx7xIdle;
                                                }
						break;
				}
				case Sx7xTxInit:
				{
						SX78TxInit();
						Sx7xState = Sx7xTxIng;
						break;
				}
				case Sx7xTxIng:
				{
						if(SX7xTxStart(SX78Str.SX7xTxStr,SX78Str.SX7xTxlen,&SX78Str.SX7xTxFlag)==3)
						{
							SX78Str.SX7xTxFlag = FALSE;
							//Sx7xState=Sx7xRxInit;
                                                        Sx7xState = Sx7xInit;
                                                        //if(!LOW_POWER_TEST)GPIO_ToggleBits(GPIOA,GPIO_Pin_5);
							if(TxModel)
                                                          {

							}
							memset(SX78Str.SX7xTxStr,0,0x80*2*sizeof(uint8_t));
						}
						break;
				}
				default:
					break;
		}
}







